$nodownload=0;
$nodownload=1 if (shift @ARGV) eq "--nodl"; 


$smokepingtempdir="--smokeping224--";
$smokepingexdir="smokeping-2.2.4";
$smokeurl="http://oss.oetiker.ch/smokeping/pub/smokeping-2.2.4.tar.gz";
$rrdurl="http://oss.oetiker.ch/rrdtool/pub/rrdtool-1.2.15-win32-perl58.zip";
$fpingurl="http://dev.pulsed.net/misc/fping.zip";

$smoketarfile=$smokeurl;
$smoketarfile=~s#^.+\/##;
$rrdzipfile=$rrdurl;
$rrdzipfile=~s#^.+\/##;
$fpingzipfile=$fpingurl;
$fpingzipfile=~s#^.+\/##;



if($nodownload==0)
{
rmrf($smokepingtempdir) if -d $smokepingtempdir;
mkdir "$smokepingtempdir";
}
elsif(!-d $smokepingtempdir)
{
mkdir "$smokepingtempdir";
die "please download:$/- $smokeurl$/- $rrdurl$/- $fpingurl$/and put them in $smokepingtempdir (no extraction needed)$/";

}
elsif(!-f "$smokepingtempdir\\$smoketarfile" || !-f "$smokepingtempdir\\$rrdzipfile" || !-f "$smokepingtempdir\\$fpingzipfile")
{
die "please download:$/- $smokeurl$/- $rrdurl$/- $fpingurl$/and put them in $smokepingtempdir (no extraction needed)$/";
}


checkmodules("Archive::Zip");
checkmodules("Archive::Tar");
checkmodules("Text::Patch");

require Archive::Zip;
require Archive::Tar;
require Text::Patch;

################################################################################

my $perlpath="";
my $perlfoundcount=0;
for(split /;/,$ENV{'path'})
{
if (-f $_."\\perl.exe")
{
$perlpath.=$perlfoundcount ==0?$_."\\perl.exe":$/.$_."\\perl.exe";
$perlfoundcount++;
}
}

{
local $/=undef;
$perlpath=~s#\\\\#\\#g;
}


if($perlfoundcount==1)
{
print "i found the perl executable here $perlpath$/press enter if that's ok, or type the correct path to the perl interpreter executable$/";
}
elsif($perlfoundcount==0)
{
print "unable to find the perl executable, where is the perl interpreter ?$/";
}
else
{
print "Found multiple perl executables: $/$perlpath $/ type the correct path to the perl interpreter executable$/";
}

my $newperlpath=<>;
chomp $newperlpath;

if(!-f $newperlpath && -f "$newperlpath\\perl.exe")
{
$newperlpath="$newperlpath\\perl.exe";
}

if($newperlpath ne "")
{
if(-f $newperlpath)
{
$perlpath=$newperlpath;
}
else
{
die "$newperlpath doesn't exist$/";
}
}
elsif(!-f $perlpath)
{
die "hey help me to find perl!!$/";
}

{
local $/=undef;
$perlpath=~s#\\\\#\\#g;
}



print "Where do we install smokeping? [Default: C:\\$smokepingexdir]$/";
my $smokepingpath=<>;
chomp $smokepingpath;
if($smokepingpath eq "")
{
$smokepingpath="C:\\$smokepingexdir";
}



if(!($smokepingpath=~m/^[a-z]\:\\.+/i)) {die("$smokepingpath is not ok");}
 
if(! -d $smokepingpath)
{
die("something went wrong while creating $smokepingpath ($!)") if(!mkdir $smokepingpath);
}
else
{
$newname=$smokepingpath."-".time;
print "$/$smokepingpath already exists, renaming it in $newname$/";
rename $smokepingpath, $newname;
die("something went wrong while creating $smokepingpath ($!)") if(!mkdir $smokepingpath);
}
$smokepingpathnew=$smokepingpath;
$smokepingpathnew=~s#\\#/#g;
$smokepingpathnew=~s#/+$##;

################################################################################

print "$/Owner (your name should be ok)$/";
my $owner=<>;
chomp $owner;

print "$/contact mail (as displayed on the smokeping page)$/";
my $mail=<>;
chomp $mail;

print "$/SMTP host (not using PopBeforeSMTP or something)$/";
my $smtp=<>;
chomp $smtp;

print "$/WWW root folder [Default: C:\\wamp\\www] (must already exist)$/";
my $wwwroot=<>;
chomp $wwwroot;
if($wwwroot eq "")
{
$wwwroot="C:\\wamp\\www";
}

$wwwroot=~s#/#\\#g;
if(! -d $wwwroot)
{
die("$wwwroot does not exist");
}
$wwwroot=~s#\\+$##g;

print "$/image folder from $wwwroot [Default: simg]$/";
my $imagefolder=<>;
chomp $imagefolder;
if($imagefolder eq "")
{
$imagefolder="simg";
}


if(! -d $wwwroot."\\".$imagefolder)
{
die("something went wrong while creating $wwwroot\\$imagefolder ($!)") if(!mkdir $wwwroot."\\".$imagefolder);
}

$imagecache=$wwwroot."\\".$imagefolder;
$imagecache=~s#\\+#/#g;

$imgurl="../".$imagefolder;
$imgurl=~s#//+#/#g;

print "$/cgi url (not sure what exactly this is for)  [Default: http://127.0.0.1/cgi-bin/smokeping.pl]$/";
my $cgiurl=<>;
chomp $cgiurl;
if($cgiurl eq "")
{
$cgiurl="http://127.0.0.1/cgi-bin/smokeping.pl";
}

print "$/cgi folder [Default: c:\\wamp\\cgi]  (must already exist)$/";
my $cgifolder=<>;
chomp $cgifolder;
if($cgifolder eq "")
{
$cgifolder="c:\\wamp\\cgi";
}

if(! -d $cgifolder)
{
die("$cgifolder does not exist");
}


print "$/Alerts: \"alertee\"$/";
my $alertsto=<>;
chomp $alertsto;

print "$/Alerts: sender email (can be fake)$/";
my $alertsfrom=<>;
chomp $alertsfrom;





chdir "$smokepingtempdir";

if($nodownload==0)
{
`lwp-download $smokeurl`;
die ("Error downloading $smokepingexdir$/") if $?!=0;

`lwp-download $rrdurl`;
die ("Error downloading rrdtool-1.2.15-win32-perl58$/") if $?!=0;

`lwp-download $fpingurl`;
die ("Error downloading fping$/") if $?!=0;
}



my $somezip = Archive::Zip->new();
unless ( $somezip->read( "$rrdzipfile" ) == AZ_OK ) {
die "unable to unzip $rrdzipfile";
}

for($somezip->members())
{
$somezip->extractMember($_);
}

my $somezip2 = Archive::Zip->new();
unless ( $somezip2->read( "$fpingzipfile" ) == AZ_OK ) {
die "unable to unzip $fpingzipfile";
}

for($somezip2->memberNames())
{
$somezip2->extractMember($_,"$smokepingexdir\\fping\\".$_);
}


$class="RRDs";
my $rrdvers;
eval "require $class; ";
$rrdvers=$RRDs::VERSION;

if($@ or $rrdvers < 1.2015)
{
print "installing RRDs$/";
$res=`ppm install rrdtool\\bindings\\perl-shared\\RRDs.ppd`;
print "$res $/$/OK  $?$/";
}




my $tar = Archive::Tar->new;
$tar->read("$smoketarfile",1);



for(grep(/\:/,$tar->list_files()))
{
my $name=$_;
my $newname=$name;
$newname =~ s/\://eg; 
$tar->rename($name,$newname);
}

$tar->extract();

# lets rename
rename "$smokepingexdir\\bin\\smokeping.dist","$smokepingexdir\\bin\\smokeping.pl";
rename "$smokepingexdir\\bin\\tSmoke.dist","$smokepingexdir\\bin\\tSmoke.pl";
rename "$smokepingexdir\\htdocs\\smokeping.cgi.dist","$smokepingexdir\\htdocs\\smokeping.pl";

chdir "..";



opendir(DIR, ".") || die "can't opendir $some_dir: $!";
@dir = grep { /\.diff$/ && -f "$_" } readdir(DIR);
closedir DIR;

for(@dir)
{
my $org;
my $diff;

my $filename="$smokepingtempdir\\$smokepingexdir\\".$_;
my $regex="\\";
$filename=~s/\#/$regex/g;
$filename=~s/\.diff$//eg;

{
local $/=undef;
open(FH,"<",$_);
$diff=<FH>;
close FH;

$diff=~s#>>owner<<#$owner#ig;
$diff=~s#>>mail<<#$mail#ig;
$diff=~s#>>mailserv<<#$smtp#ig;
$diff=~s#>>imgcache<<#$imagecache#ig;
$diff=~s#>>imgurl<<#$imgurl#ig;
$diff=~s#>>smokepingpath<<#$smokepingpathnew#ig;
$diff=~s#>>cgiurl<<#$cgiurl#ig;
$diff=~s#>>alertsto<<#$alertsto#ig;
$diff=~s#>>alertsfrom<<#$alertsfrom#ig;
$diff=~s#>>perlpath<<#$perlpath#ig;



open(FH,"<",$filename);
$org=<FH>;
close FH;
}


$out  = Text::Patch::patch( $org, $diff, { STYLE => 'Unified' } );
open(FH,">",$filename);

print FH $out;
close FH;
}



cp("$smokepingtempdir\\$smokepingexdir",$smokepingpath);
cp("$smokepingpath\\htdocs\\cropper","$imagecache\\cropper");

mkdir("$smokepingpath\\var");

my $path="$smokepingpath\\htdocs\\smokeping.pl";


$path=~s#/#\\#g;
$path=~s#\\\\+#\\#g;


$rpath=$cgifolder."\\smokeping.pl";

#copy cgi file
if(-f $path)
{
open(FHR,"<",$path);
binmode FHR;
open(FHW,">",$rpath);
binmode FHW;

while(<FHR>)
{
print FHW $_;
}
close FHR;
close FHW;
}
else
{
print "$/unable to copy htdocs\\smokeping.pl ($rpath) $/";
}

rmrf($smokepingtempdir) if -d $smokepingtempdir && $nodownload==0;


sub rmrf($) {
my $dir = shift;
opendir(DIR, $dir);
for(readdir(DIR)) {
next if /^\.\.?/;
my $path = "$dir/$_";
unlink $path if -f $path;
rmrf($path) if -d $path;	}
closedir(DIR);
rmdir $dir;
}



sub cp($$$)
{
      my $src = shift;
      my $dest = shift;
      my $base = scalar(@_)?shift:$src;

      mkdir $dest if !-d $dest;
      
      opendir(DIR, $src);
      for(readdir(DIR))
      {
            next if /^\.\.?/;
            my $path=$src."/".$_;
            my $rpath=$path;
            my $qb=quotemeta($base);
            $rpath=~ s#$qb#$dest#i;
            
            
            $rpath=~s#\\\:#:#g;
            $rpath=~s#\\\\+#\\#g;
            
            
            if(-f $path)
            {
            open(FHR,"<",$path);
            binmode FHR;
            open(FHW,">",$rpath);
            binmode FHW;
            while(<FHR>)
            {
                  print FHW $_;
            }
            close FHR;
            close FHW;
            }
            mkdir $rpath if -d $path;
            cp($path,$dest ,$base) if -d $path;	
      }
      closedir(DIR);
}



sub checkmodules($)
{

$class=shift;
eval "require $class";

if($@)
{
print "installing $class$/";
$class=~s#\:\:#-#g;
`ppm install $class`;
}


}
